# Class OjTreeView

The component WebElement for oj-tree-view. Do not instantiate this class directly, instead, use ojTreeView.

#### Hierarchy

- OjTreeViewBase
  - OjTreeView

#####
Index

### Constructors

constructor

### Methods

changeExpanded
changeSelected
changeSelection
clear
click
doCollapse
doExpand
findElement
findElements
findItem
getAttribute
getCssValue
getCurrentItem
getDnd
getDriver
getId
getItem
getLocation
getProperty
getRect
getScrollPolicyOptions
getSelected
getSelection
getSelectionMode
getShadowRoot
getSize
getTagName
getText
getTranslations
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjTreeView(el, locators): OjTreeView

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjTreeView

  Inherited from OjTreeViewBase.constructor

## Methods

### changeExpanded

- changeExpanded(expanded): Promise<void>

- Sets the value of "expanded" property. Specifies the key set containing the keys of the items that should be expanded. Use the ExpandedKeySet class to specify items to expand. Use the ExpandAllKeySet class to expand all items.

  #### Parameters

  - ##### expanded: any[]

    The value to set for "expanded"

  #### Returns Promise<void>

### changeSelected

- changeSelected<K>(selected): Promise<void>

- Sets the value of "selected" property. Specifies the current selected items in the treeview. See the Help documentation for more information.

  ### Typeparam

  K Type of keys

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### selected: K[]

    The value to set for "selected"

  #### Returns Promise<void>

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. Specifies the current selections in the tree. An empty array indicates nothing is selected.

  ### Deprecated

  Since 8.0.0. Use selected attribute instead.

  #### Parameters

  - ##### selection: any[]

    The value to set for `selection`

  #### Returns Promise<void>

  Inherited from OjTreeViewBase.changeSelection

### clear

- clear(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjTreeViewBase.clear

### click

- click(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjTreeViewBase.click

### doCollapse

- doCollapse<T>(itemLocator): Promise<void>

- Collapses an expanded treeview item. If already collapsed it will remain collapsed.

  #### Type Parameters

  - #### T

  #### Parameters

  - ##### itemLocator: {
    id?: string;
    key?: T;
    }

    - ##### `Optional` id?: string

    - ##### `Optional` key?: T

  #### Returns Promise<void>

### doExpand

- doExpand<T>(itemLocator): Promise<void>

- Expands a collapsed treeview item. If already expanded it will remain expanded.

  #### Type Parameters

  - #### T

  #### Parameters

  - ##### itemLocator: {
    id?: string;
    key?: T;
    }

    - ##### `Optional` id?: string

    - ##### `Optional` key?: T

  #### Returns Promise<void>

### findElement

- findElement(locator): WebElementPromise

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  Inherited from OjTreeViewBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  Inherited from OjTreeViewBase.findElements

### findItem

- findItem<T>(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents a single treeview item.

  #### Type Parameters

  - #### T

  #### Parameters

  - ##### itemLocator: {
    id?: string;
    key?: T;
    }

    - ##### `Optional` id?: string

    - ##### `Optional` key?: T

  #### Returns Promise<SlotProxy>

### getAttribute

- getAttribute(attributeName): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  Inherited from OjTreeViewBase.getAttribute

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  Inherited from OjTreeViewBase.getCssValue

### getCurrentItem

- getCurrentItem(): Promise<any>

- Gets the value of `currentItem` property. Read-only property used for retrieving the key of the item that currently has focus.

  #### Returns Promise<any>

  The value of `currentItem` property.

  Inherited from OjTreeViewBase.getCurrentItem

### getDnd

- getDnd(): Promise<Dnd>

- Gets the value of `dnd` property. Customizes the drag and drop functionality. See the Help documentation for more information.

  #### Returns Promise<Dnd>

  The value of `dnd` property.

  Inherited from OjTreeViewBase.getDnd

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjTreeViewBase.getDriver

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjTreeViewBase.getId

### getItem

- getItem(): Promise<Item>

- Gets the value of `item` property. Customizes the functionality of each item in the tree.

  #### Returns Promise<Item>

  The value of `item` property.

  Inherited from OjTreeViewBase.getItem

### getLocation

- getLocation(): Promise<ILocation>

- ### Inherit Doc

  #### Returns Promise<ILocation>

  Inherited from OjTreeViewBase.getLocation

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjTreeViewBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- ### Inherit Doc

  #### Returns Promise<IRectangle>

  Inherited from OjTreeViewBase.getRect

### getScrollPolicyOptions

- getScrollPolicyOptions(): Promise<unknown>

- Gets the value of `scrollPolicyOptions` property. Specifies fetch options for scrolling behaviors that trigger data fetches. See the Help documentation for more information.

  #### Returns Promise<unknown>

  The value of `scrollPolicyOptions` property.

  Inherited from OjTreeViewBase.getScrollPolicyOptions

### getSelected

- getSelected<K>(): Promise<K[]>

- Gets the value of "selected" property. Retrieves the current selected items in the treeview. See the Help documentation for more information.

  ### Typeparam

  K Type of keys

  #### Type Parameters

  - #### K

  #### Returns Promise<K[]>

  The value of "selected" property.

### getSelection

- getSelection(): Promise<any[]>

- Gets the value of `selection` property. Specifies the current selections in the tree. An empty array indicates nothing is selected.

  ### Deprecated

  Since 8.0.0. Use selected attribute instead.

  #### Returns Promise<any[]>

  The value of `selection` property.

  Inherited from OjTreeViewBase.getSelection

### getSelectionMode

- getSelectionMode(): Promise<string>

- Gets the value of `selectionMode` property. Specifies the selection mode.

  #### Returns Promise<string>

  The value of `selectionMode` property.

  Inherited from OjTreeViewBase.getSelectionMode

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjTreeViewBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- ### Inherit Doc

  #### Returns Promise<ISize>

  Inherited from OjTreeViewBase.getSize

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjTreeViewBase.getTagName

### getText

- getText(): Promise<string>

- ### Inherit Doc

  #### Returns Promise<string>

  Inherited from OjTreeViewBase.getText

### getTranslations

- getTranslations(): Promise<Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<Translations>

  The value of `translations` property.

  Inherited from OjTreeViewBase.getTranslations

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  ### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  Inherited from OjTreeViewBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  ### Deprecated

  #### Returns Condition<Promise<boolean>>

  Inherited from OjTreeViewBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjTreeViewBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjTreeViewBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjTreeViewBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- ### Inherit Doc

  #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  Inherited from OjTreeViewBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjTreeViewBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjTreeViewBase.setProperty

### submit

- submit(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjTreeViewBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  Inherited from OjTreeViewBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjTreeViewBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjTreeViewBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjTreeViewBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjTreeViewBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  ### Throws

  if the object is not a valid encoded ID.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  Inherited from OjTreeViewBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjTreeViewBase.isId

Generated using TypeDoc